unit MD5CalcD;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, MD5;

type
  TCopyDlg = class(TForm)
    RBtAsText: TRadioButton;
    EdSpc: TEdit;
    RBtAsInc: TRadioButton;
    CmbLng: TComboBox;
    BtnOk: TBitBtn;
    BtnCancel: TBitBtn;
    CbxUpcase: TCheckBox;
    CbxSpc: TCheckBox;
    procedure CheckEnables(Sender: TObject);
    procedure BtnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CmbLngChange(Sender: TObject);
  private
    { Private-Deklarationen }
    FMD5: TMD5;
    FSpc: byte;
  public
    { Public-Deklarationen }
    property TheMD5: TMD5 write FMD5;
  end;

var
  CopyDlg: TCopyDlg;

implementation

{$R *.DFM}

uses Clipbrd;

procedure TCopyDlg.CheckEnables(Sender: TObject);
var Valid: boolean;
    err  : integer;
begin
  if CbxSpc.Checked then begin
    Val (EdSpc.Text,FSpc,err);
    Valid:=err=0;
    end
  else begin
    FSpc:=0;
    Valid:=true;
  end;
  if Valid and RBtAsInc.Checked then Valid:=CmbLng.ItemIndex>=0;
  BtnOk.Enabled:=Valid;
end;

procedure TCopyDlg.BtnOkClick(Sender: TObject);
var s,Hex : string;
    i,j   : longint;
    ok    : boolean;
begin
  CheckEnables (Sender);
  ok:=BtnOk.Enabled;
  if ok then begin
    if RBtAsInc.Checked then begin
      if CbxUpcase.Checked
        then Hex:='0123456789ABCDEF' else Hex:='0123456789abcdef';
      s:='';
      case CmbLng.ItemIndex of
        0: begin
            Str (MD5Size-1,s);
            s:='const MD5CHECKSUM: packed array[0..'+s+'] of byte { TMD5 } ='#13#10;
            s:=s+'  (';
            for i:=0 to MD5Size-1 do begin
              if i>0 then s:=s+',';
              if FSpc>0 then for j:=1 to FSpc do s:=s+' ';
              s:=s+'$'
                +Hex[((FMD5[i] shr 4) and $0F)+1]+Hex[(FMD5[i] and $0F)+1];
            end;
            if FSpc>0 then for j:=1 to FSpc do s:=s+' ';
            s:=s+');';
          end;
        1: begin
            Str (MD5Size,s);
            s:='unsigned char MD5CHECKSUM['+s+'] ='#13#10;
            s:=s+'  {';
            for i:=0 to MD5Size-1 do begin
              if i>0 then s:=s+',';
              if FSpc>0 then for j:=1 to FSpc do s:=s+' ';
              s:=s+'0x'
                +Hex[((FMD5[i] shr 4) and $0F)+1]+Hex[(FMD5[i] and $0F)+1];
            end;
            if FSpc>0 then for j:=1 to FSpc do s:=s+' ';
            s:=s+'}';
          end;
        else ok:=false;
      end;
      end
    else if RBtAsText.Checked
      then s:=MD5AsString (FMD5,CbxUpcase.Checked,FSpc)
    else ok:=false;
  end;
  if not ok then begin
    ModalResult:=mrNone;
    exit;
  end;
  Clipboard.Clear;
  ClipBoard.AsText:=s+#13#10;
end;

procedure TCopyDlg.FormCreate(Sender: TObject);
begin
  CmbLng.ItemIndex:=0;
end;

procedure TCopyDlg.CmbLngChange(Sender: TObject);
begin
  RBtAsInc.Checked:=true;
end;

end.

