unit MD5CalcF;

interface

uses
  Windows, Graphics, Forms, StdCtrls, Dialogs, Classes, Controls,
  Buttons, Menus, ExtCtrls, Messages, MD5;

type
  TMainForm = class(TForm)
    OpenDlg: TOpenDialog;
    SBtOpen: TSpeedButton;
    LblFile: TLabel;
    PnlFile: TPanel;
    PnlMD5: TPanel;
    LblMD5: TLabel;
    SBtCopy: TSpeedButton;
    procedure OpenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SBtCopyClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FFN: string;
    FMD5: TMD5;
    procedure WMDropFiles (var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure ShowInfo;
    function  CheckFile (const fn: string): boolean;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ShellApi, SysUtils, MD5CalcD;

function FitFilename (s: string; AFont: TFont; AMaxWidth: longint): string;
var sa,sb : string;
    i     : longint;
    DC    : HDC;
    OldFnt: HFont;
  function TW (s: string): longint;
  var Size: TSize;
  begin
    GetTextExtentPoint32 (DC,PChar (s),Length (s),Size);
    Result:=Size.cx;
  end;
begin
  if (s<>'') and Assigned (AFont) then begin
    DC:=CreateCompatibleDC (0);
    OldFnt:=SelectObject (DC,AFont.Handle);
    sa:=s;
    if TW (sa)>AMaxWidth then begin
      i:=Pos ('\',sa);
      if i>0 then while sa[i]='\' do Inc (i) else i:=1;
      sb:=Copy (sa,i,Length (sa)+1-i);
      sa:=Copy (sa,1,i-1)+'...';
      while (sb<>'') and (TW (sa+sb)>AMaxWidth) do
        Delete (sb,1,1);
      end
    else sb:='';
    SelectObject (DC,OldFnt);
    DeleteDC (DC);
    Result:=sa+sb;
    end
  else Result:='';
end;

procedure TMainForm.WMDropFiles (var Msg: TWMDropFiles);
var n  : integer;
    fn : array[0..255] of char;
begin
  n:=DragQueryFile (Msg.Drop,$FFFFFFFF,nil,0);
  if n>0 then begin
    DragQueryFile (Msg.Drop,0,fn,SizeOf (fn));
    CheckFile (StrPas (fn));
  end;
  DragFinish (Msg.Drop);
end;

procedure TMainForm.ShowInfo;
var Valid: boolean;
begin
  with PnlFile do Caption:=FitFilename (' '+FFN,Font,ClientWidth-12);
  Valid:=FFN<>'';
  if Valid
    then PnlMD5.Caption:=MD5AsString (FMD5,false,1)
    else PnlMD5.Caption:='';
  SBtCopy.Enabled:=Valid;
end;

function TMainForm.CheckFile (const fn: string): boolean;
var NewMD5: TMD5;
begin
  Screen.Cursor:=crHourGlass;
  Result:=MD5CalcFile (fn,NewMD5);
  Screen.Cursor:=crDefault;
  if Result then begin
    FFN:=fn;
    FMD5:=NewMD5;
    ShowInfo;
    end
  else MessageDlg ('Cannot read the file '+fn+' !',mtError,[mbOk],0);
end;

procedure TMainForm.OpenClick(Sender: TObject);
begin
  if OpenDlg.Execute then CheckFile (OpenDlg.Filename);
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  FFN:='';
  FillChar (FMD5,SizeOf (FMD5),0);
  Application.ShowHint:=true;
  ShowInfo;
  DragAcceptFiles (Handle,true);
  if ParamCount>0 then CheckFile (ParamStr (1));
end;

procedure TMainForm.SBtCopyClick(Sender: TObject);
begin
  CopyDlg.TheMD5:=FMD5;
  CopyDlg.ShowModal;
end;

end.

